/***************************************************************************
 *            contactswindow.h
 *
 *  Wed May 17 00:58:53 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _CONTACTSWINDOW_H
#define _CONTACTSWINDOW_H

#include "basicwindow.h"
#include "requestdialog.h"
#include "imuserdaemon.h"
#include "contactsselection.h"
#include "userutilities.h"
#include "imbuddy.h"


class contactsWindow: public requestDialog
{
	public:
		contactsWindow(gboolean _isServer);
		~contactsWindow();
	
		void addContact(IMUserDaemon* contact);
		
	private:
		contactsSelection	*selection;
		GtkWidget	*infoButton,
					*chatButton,
					*filetransferButton,
					*messageButton,
					*addUsersButton,
					*alertUsersCheckbox,
					*contactsView;
	
		gint		addCount;
	
		GtkListStore	*contactsStore;
	
		GtkWidget *createWindowContent();
		GtkWidget *createServerRequestWidget();
		GtkWidget *createRemoteWidget();
		void	  destroyWindowContent();
		gboolean  sendSelectedContacts();
		void	  fillContactsBox(contactsEventInfo* info);
	
		GtkWidget	*createButtonbar();
		void		updateAddButton();
	
	
		static void cb_requestCallback(gint result, gpointer info, contactsWindow* self);
		static void cb_contactsAddToggled(GtkCellRendererToggle *cell, gchar *pathStr, contactsWindow* self);

		static void cb_contactsFocusChanged(contactsWindow* self); 
		static void cb_userButtonClicked(GtkWidget* w, contactsWindow* self);
		static void cb_addUsersButtonClicked(contactsWindow* self);

		static void cb_selectionEntryDropped(contactsWindow* self, 
										   		 GdkDragContext   *drag_context,
                                            	 gint              x,
                                            	 gint              y,
                                            	 GtkSelectionData *data,
                                            	 guint             info,
                                            	 guint             time);
												 
		gboolean eventCallback(gint command, gint lastResult, gpointer info);
};



#endif /* _CONTACTSWINDOW_H */
