/***************************************************************************
 *            groupswindow.h
 *
 *  Thu Jun 30 01:22:56 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _GROUPSWINDOW_H
#define _GROUPSWINDOW_H
#include "basicwindow.h"
#include "utilities.h"
#include "gettext.h"
#include "notebookbox.h"

typedef void (*groupsWindowCallback)(gint command, gpointer data);

class groupsWindow: public basicWindow
{
	public:
		groupsWindow(groupsWindowCallback _cb, gpointer _cbdata);
		~groupsWindow();
	
		
	protected:
		groupsWindowCallback cb;
		gpointer	cbdata;	
	
		GtkListStore	*store;
		GtkWidget		*addButton,
						*removeButton,
						*upButton,
						*downButton,
						*editButton,
						*setDefaultButton,
						*setNewButton,
						*defaultGroupLabel,
						*newUsersGroupLabel,
						*closeButton,
						*saveButton,
						*tv;
		GtkCellRenderer *textRenderer;
	
		GtkTreeViewColumn	*textColumn;
	
		gushort			newUsersGroup,
						defaultGroup;
		guint			ownID;
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
	
		GtkWidget	*createGroupsList();
		GtkWidget	*createButtonbar();
	
		static void cb_groupListCursorChanged(groupsWindow* self);
		static void cb_addButtonClicked(groupsWindow* self);
		static void cb_removeButtonClicked(groupsWindow* self);
		static void cb_upButtonClicked(groupsWindow* self);
		static void cb_downButtonClicked(groupsWindow* self);
		static void cb_editButtonClicked(groupsWindow* self);
		static void cb_defaultGroupButtonClicked(groupsWindow* self);
		static void cb_newGroupButtonClicked(groupsWindow* self);
		static void cb_groupEntryEdited(GtkCellRendererText *cell, gchar *pathStr, gchar *newText, groupsWindow* self);

		static void cb_saveButtonClicked(groupsWindow* self);
		static void cb_closeButtonClicked(groupsWindow* self);	
};


#endif /* _GROUPSWINDOW_H */
