/***************************************************************************
 *            trayicon.h
 *
 *  Tue Sep  7 01:10:03 2004
 *  Copyright  2004  User
 *  Email
 ****************************************************************************/

#ifndef _TRAYICON_H
#define _TRAYICON_H

#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gtk/gtk.h>
#include <string.h>


#define SYSTEM_TRAY_REQUEST_DOCK    0
#define SYSTEM_TRAY_BEGIN_MESSAGE   1
#define SYSTEM_TRAY_CANCEL_MESSAGE  2





class trayIcon
{
	public:
	
		GdkDisplay	*gdkDisplay;
		Display		*xdisplay;
		GdkScreen	*gdkScreen;

		Atom	systemTraySelection,
				xManager,
				managerCommand;	
	
		Window  trayWindow;
	
		GtkWidget	*pluggedIcon,
					*eventWidget,
					*iconWidget;
	
	
		trayIcon();
		~trayIcon();
	
		// installs a tray icon
		gboolean installTrayIcon(GtkWidget* icon);
		// removes the trax icon
		void	 removeTrayIcon();
	
		// gets the x-window that is the system tray
		void getSystemTrayWindow();
	
	private:
		// sends a message to the active x-server
		void sendXMessage(	Atom atom, glong message, 
							glong data1, glong data2, glong data3);
		// creates the gtk tray icon
		void createTrayIconWindow();
	
};


GdkFilterReturn tIsystemTrayChange(GdkXEvent *xevent, GdkEvent *event, trayIcon* ti);

#endif /* _TRAYICON_H */
