/***************************************************************************
 *            utilities.h
 *
 *  Thu Aug 26 01:23:48 2004
 *  Copyright  2004  User
 *  Email
 ****************************************************************************/

#ifndef _UTILITIES_H
#define _UTILITIES_H

#include <gtk/gtk.h>
#include <gdk/gdk.h>
// #include <gdk/gdkx.h>
#include <iostream>
#include "gettext.h"
#include "icons.h"
#include "settings.h"

enum
{
	STRUT_LEFT,
	STRUT_RIGHT,
	STRUT_TOP,
	STRUT_BOTTOM,
	STRUT_LEFT_START_Y,
	STRUT_LEFT_END_Y,
	STRUT_RIGHT_START_Y,
	STRUT_RIGHT_END_Y,
	STRUT_TOP_START_X,
	STRUT_TOP_END_X,
	STRUT_BOTTOM_START_X,
	STRUT_BOTTOM_END_X
};



enum u_menuType
{
	UMENU_NORMAL,
	UMENU_CHECK,
	UMENU_RADIO,
	UMENU_SEPARATOR,
	UMENU_HEADLINE
};


typedef struct _borderInfo
{
	long	left, right, top, bottom;
} borderInfo;


// structure for a menu item
typedef struct u_menuItem
{
	u_menuType  type;
	guint		id;		
	gchar* 		stockIcon;	
	char* 		title;	
	
	GtkMenu*	subMenu;
	
	gboolean	enabled,
				selected;
	
	guchar		groupID;
	GtkWidget** target;
	GdkPixbuf	*pixbuf;
};


enum aWebBrowser
{
	BR_MOZILLA,
	BR_FIREFOX,
	BR_NETSCAPE,
	BR_OPERA,
	BR_EPIPHANY,
	BR_KONQUEROR,
	BR_GALEON
};

enum aWebBrowserMode
{
	WMODE_WINDOW,
	WMODE_TAB,
	WMODE_CURRENT
};


typedef struct u_browserInfo
{
	gchar	*name,
			*command;
	aWebBrowser id;
	
};



const struct u_browserInfo icqndWebBrowsers[] =
{
	{"Mozilla Firefox"	, "firefox"		, BR_FIREFOX},	
	{"Mozilla Browser"	, "mozilla"		, BR_MOZILLA},
	{"Epiphany"			, "epiphany"	, BR_EPIPHANY},	
	{"Netscape"			, "netscape"	, BR_NETSCAPE},
	{"Opera"			, "opera"		, BR_OPERA},
	{"Konqueror"		, "kfmclient"	, BR_KONQUEROR},
	{"Galeon"			, "galeon"		, BR_GALEON},
	{NULL}
};


GList* u_getInstalledBrowsers();
u_browserInfo* u_getBrowserByCommand(gchar* cmd);
u_browserInfo* u_getFirstInstalledBrowser();


void u_showAlertMessage(gchar* headline, gchar *message, gchar* iconstock);
gint u_showYesNoDialog(gchar* headline, gchar *message, gchar* iconstock, gboolean hasCancel);
gint u_showYNRememberDialog(gint dialogID, gchar* headline, GtkWidget *content, ...); 
void u_showFileWriteError(FILE* f);

GtkWidget* u_createImageButton(GtkWidget* label, GtkWidget* img);
void u_setWidgetBackground(GtkWidget *widget, gchar* col);
GtkWidget* u_createStockImageButton(gchar* stockIcon);
void u_setStockButtonImage(GtkWidget* button, gchar* stockIcon);
GtkWidget* u_createTextStockImageButton(gchar* text, gchar* stockIcon);
GtkWidget* u_changeTextStockImageButton(GtkWidget* w, gchar* text, gchar* stockIcon);

void u_createTableRow(GtkWidget* tbl, char* name1, GtkWidget** el1, char* name2, GtkWidget** el2, gint row);

GtkWidget* u_createTextView(GtkWidget** twidget);

GtkWidget* u_createHeadline(gchar* txt, gchar* alttxt, gchar* imageStock);

GtkMenu* u_createMenuList(u_menuItem* menulist, gchar elements, GtkSignalFunc cbfunc, gint menuID, gpointer data, gboolean showIcons);
void	 u_editMenuEntry(GtkWidget* menuEntry, gchar* newImage, gchar* newText);

GdkPixbuf* u_getPixbufFromStock(gchar* stockName, GtkIconSize size);

gchar* u_convertSize2Readable(gint size);
gchar* u_getTimeDistance(time_t t1, time_t t2);

GList* u_getUNumbersFromString(gchar* str);
gchar* u_getStringFromNumbers(GList* list);

void u_stripStringByNeedle(gchar* str, gchar* needle);
void u_appendToString(gchar** str, gchar* toAppend);

void u_insertTextInterpretedIntoView(gchar* toAppend, gchar* tagName, gboolean createMargin, gboolean interpretURIs, gboolean interpretSmileys, GtkTextIter* pos, GtkTextView* viewToInsert);
void u_checkInterpretedViewForURLCursor(gint x, gint y, GtkTextView* view, gchar** hoveredLink);


// X11 functions
borderInfo*	u_getDisplayBorders();
gboolean	u_dockWindow(GtkWidget* wnd, gchar dir);
void		u_getDisplaySize(GtkWidget* w, gint* width, gint* height);

#endif /* _UTILITIES_H */
